{{ $appSection := "frontend" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName }}
  annotations:
    {{- include "golemiocz.annotations" . | nindent 4 }}
  labels:
    app.kubernetes.io/name: {{ $appName }}
    backstage.io/kubernetes-id: {{ $appName }}
    {{- include "golemiocz.labels" . | nindent 4 }}
spec:
  replicas: {{ index . "Values" $appSection "replicas" }}
  strategy: {{- include "golemiocz.rollingUpdate" (index . "Values" $appSection) | nindent 4 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ $appName }}
      {{- include "golemiocz.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        {{- include "golemiocz.annotations" . | nindent 8 }}
      labels:
        app.kubernetes.io/name: {{ $appName }}
        backstage.io/kubernetes-id: {{ $appName }}
        {{- include "golemiocz.labels" . | nindent 8 }}
    spec:
      automountServiceAccountToken: false
      {{- include "golemiocz.imagePullSecrets" (list . .Values.global.imagePullSecrets ) | nindent 6 }}
      containers:
        - name: {{ $appName }}
          image: {{ include "golemiocz.imageName" (list . $appSection) | quote }}
          imagePullPolicy: {{ .Values.global.pullPolicy }}
          ports:
            - containerPort: {{ index . "Values" $appSection "port" }}
          env:
            - name: SERVER_API_BASE
              value: {{ index . "Values" $appSection "apiUrl" | quote }}
            - name: SERVER_API_TOKEN
              valueFrom:
                secretKeyRef:
                  key: frontend-api-token
                  name: {{ .Values.global.secretName | quote }}
            - name: NODE_OPTIONS
              value: {{ include "golemiocz.maxOldSpaceSize" (index . "Values" $appSection "resources" "limits" "memory" ) | quote}}
            - name: PUBLIC_URL
              value: https://{{ index . "Values" $appSection "ingress" "hosts" 0 }}
            - name: NEXT_PUBLIC_LOG_LEVEL
              value: {{ index . "Values" $appSection "logLevel" }}
            - name: POWER_BI_CLIENT_ID
              valueFrom:
                secretKeyRef:
                  key: frontend-powerbi-clientid
                  name: {{ .Values.global.secretName | quote }}
            - name: POWER_BI_USERNAME
              valueFrom:
                secretKeyRef:
                  key: frontend-powerbi-username
                  name: {{ .Values.global.secretName | quote }}
            - name: POWER_BI_PASSWORD
              valueFrom:
                secretKeyRef:
                  key: frontend-powerbi-password
                  name: {{ .Values.global.secretName | quote }}
            - name: POWER_BI_TENANT_ID
              valueFrom:
                secretKeyRef:
                  key: frontend-powerbi-tenantid
                  name: {{ .Values.global.secretName | quote }}
            - name: POWER_BI_CLIENT_SECRET
              valueFrom:
                secretKeyRef:
                  key: frontend-powerbi-clientsecret
                  name: {{ .Values.global.secretName | quote }}
            - name: SERVER_HOTJAR_ID
              value: {{ index . "Values" $appSection "hotjarId" | quote }}
            - name: SERVER_HOTJAR_VERS
              value: {{ index . "Values" $appSection "hotjarVers" | quote }}
          resources:
            {{ index . "Values" $appSection "resources" | toYaml | nindent 12 }}
          securityContext:
            allowPrivilegeEscalation: false
            runAsNonRoot: true
            runAsUser: 1001
            capabilities:
              drop: [ "all" ]
          {{- with index . "Values" $appSection "probes" }}
          {{- if .enabled }}
          readinessProbe: {{ .readinessProbe | toYaml | nindent 12 }}
          livenessProbe: {{ .livenessProbe | toYaml | nindent 12 }}
          {{- end }}
          {{- end }}
